Bug 524335 - [LSI 5.5 feat] update rdac scsi device handler to upstream
Summary: [LSI 5.5 feat] update rdac scsi device handler to upstream
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel
Version: 5.5
Hardware: All
OS: Linux
high
high
Target Milestone: rc
: 5.5
Assignee: Rob Evers
QA Contact: Red Hat Kernel QE team
URL:
Whiteboard:
: 520860 526241 (view as bug list)
Depends On:
Blocks: 533192 557292 496328 533941 5.5TechNotes-Updates
TreeView+ depends on / blocked
 
Reported: 2009-09-18 23:23 UTC by Babu Moger
Modified: 2018-10-27 14:28 UTC (History)
16 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
Added rdac support for the following devices: Sun StorageTek ST2500 Sun StorageTek ST2510 Sun StorageTek ST2530 Sun CSM100_R_FC Dell PowerVault MD32xx Dell PowerVault MD32xxi A bug was fixed where incorrect sense data needed to be flagged as present to upper layers when not handled by the rdac device handler.
Clone Of:
Environment:
Last Closed: 2010-03-30 07:24:48 UTC


Attachments (Terms of Use)
Add support for Sun StorageTek ST2500, ST2510 and ST2530 (1.23 KB, patch)
2009-09-18 23:33 UTC, Babu Moger
no flags Details | Diff
Add support for two more SUN devices (837 bytes, patch)
2009-09-18 23:34 UTC, Babu Moger
no flags Details | Diff
Add support for next generation of Dell PowerVault storage array (657 bytes, patch)
2009-09-18 23:35 UTC, Babu Moger
no flags Details | Diff
Fix for returning correct mode select cmd return info (1.11 KB, patch)
2009-09-18 23:36 UTC, Babu Moger
no flags Details | Diff
[PATCH 1/3][RESUBMIT] scsi_dh_rdac: move the init code from rdac_activate to rdac_attach (2.11 KB, patch)
2009-09-18 23:41 UTC, Babu Moger
no flags Details | Diff
[PATCH 2/3][RESUBMIT] scsi_dh_rdac: changes to collect the rdac debug information during the initialization (3.92 KB, patch)
2009-09-18 23:43 UTC, Babu Moger
no flags Details | Diff
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging (2.11 KB, patch)
2009-09-18 23:45 UTC, Babu Moger
no flags Details | Diff
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging (3.97 KB, patch)
2009-09-18 23:55 UTC, Babu Moger
no flags Details | Diff
Add support for Sun StorageTek ST2500, ST2510 and ST2530 (1.24 KB, patch)
2009-09-25 23:20 UTC, Babu Moger
no flags Details | Diff
Add support for two more SUN devices (948 bytes, patch)
2009-09-25 23:24 UTC, Babu Moger
no flags Details | Diff
Add support for next generation of Dell PowerVault storage array (657 bytes, patch)
2009-09-25 23:25 UTC, Babu Moger
no flags Details | Diff
Fix for returning correct mode select cmd return info (1.11 KB, patch)
2009-09-25 23:26 UTC, Babu Moger
no flags Details | Diff
[PATCH 1/3][RESUBMIT] scsi_dh_rdac: move the init code from rdac_activate to rdac_attach (2.11 KB, patch)
2009-09-25 23:27 UTC, Babu Moger
no flags Details | Diff
[PATCH 2/3][RESUBMIT] scsi_dh_rdac: changes to collect the rdac debug information during the initialization (3.92 KB, patch)
2009-09-25 23:30 UTC, Babu Moger
no flags Details | Diff
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging (3.97 KB, patch)
2009-09-25 23:32 UTC, Babu Moger
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2010:0178 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 5.5 kernel security and bug fix update 2010-03-29 12:18:21 UTC

Description Babu Moger 2009-09-18 23:23:59 UTC
Description of problem:

Last couple of months we have been working on to add multiple patches to scsi rdac device handler. All these patches are reviewed and approved. It will be available in 2.6.32 kernel. I am opening this bugzilla to include all these patches in RHEL 5.5 whenever the window open up.  

These patches add mailnly 3 features.
 a) First three patches include new device in rdac handler
 b) One patch fixes a potential bug.
 b) Next three patches include one the fly debug functionality which is very important for us.


Here are the details of the patches

1. Add support for Sun StorageTek ST2500, ST2510 and ST2530
  http://marc.info/?l=linux-scsi&m=125132741303628&w=2

2. Add support for two more SUN devices 
  http://marc.info/?l=linux-scsi&m=125053849203620&w=2

3. Add support for next generation of Dell PowerVault storage array.
 http://marc.info/?l=dm-devel&m=125055416131006&w=2

4. Fix for returning correct mode select cmd return info 
 http://marc.info/?l=dm-devel&m=125148188605897&w=3

5. Following three patches include debugging functinalities to rdac handler.
   http://marc.info/?l=linux-scsi&m=125242415500674&w=3
   http://marc.info/?l=linux-scsi&m=125242417300729&w=3
   http://marc.info/?l=linux-scsi&m=125242421700850&w=3

I am porting all these patches on 2.6.18-164.el5. I will attach the Patches ASAP.

Comment 1 Babu Moger 2009-09-18 23:33:52 UTC
Created attachment 361724 [details]
Add support for Sun StorageTek ST2500, ST2510 and ST2530

Comment 2 Babu Moger 2009-09-18 23:34:30 UTC
Created attachment 361725 [details]
Add support for two more SUN devices

Comment 3 Babu Moger 2009-09-18 23:35:49 UTC
Created attachment 361726 [details]
Add support for next generation of Dell PowerVault storage array

Comment 4 Babu Moger 2009-09-18 23:36:55 UTC
Created attachment 361727 [details]
Fix for returning correct mode select cmd return info

Comment 5 Babu Moger 2009-09-18 23:41:40 UTC
Created attachment 361728 [details]
[PATCH 1/3][RESUBMIT] scsi_dh_rdac: move the init code from rdac_activate to rdac_attach

Comment 6 Babu Moger 2009-09-18 23:43:43 UTC
Created attachment 361729 [details]
[PATCH 2/3][RESUBMIT] scsi_dh_rdac: changes to collect the rdac debug information during the initialization

Comment 7 Babu Moger 2009-09-18 23:45:12 UTC
Created attachment 361730 [details]
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging

Comment 8 Babu Moger 2009-09-18 23:55:37 UTC
Created attachment 361731 [details]
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging

Comment 9 Andrius Benokraitis 2009-09-23 17:04:22 UTC
*** Bug 520860 has been marked as a duplicate of this bug. ***

Comment 10 Rob Evers 2009-09-23 21:14:12 UTC
I tried to apply the first attachement patch and it applied with fuzz to today's rhel5.5.

Babu - Please create an ordered patch set that applies cleanly to rhel5.4.

Andrius, can you provide a link to rhel5.4 for Babu?

Comment 11 Rob Evers 2009-09-24 17:17:43 UTC
Babu,

Can you also comment on any testing that was done to validate patches in attachments in 4, and set 5,6, and 8.

Thanks, Rob

Comment 12 Babu Moger 2009-09-24 21:01:26 UTC
Yes, I have tested these patches on 2.6.31 kernel with LSI rdac storage(base os RHEL 5.3). Patches work fine. As you know these patches add more rdac specific debug messages during the failures. Following are test details..

Configuration :  LSI rdac storage with 4 luns. I had 4 paths to each lun(2 active and 2 passive).

Ran overnight failover/failback tests.  Tests ran fine. Enabled the logging using module parameter rdac_logging. Noticed failover/failback messages in /var/log/messages file. 

Without these patches, we will not see rdac specific messages during the failures and becomes very difficult to debug.

Comment 13 Rob Evers 2009-09-25 12:49:15 UTC
Babu,

Unfortunately the testing of these patches w/ the 2.6.31 kernel is not sufficient for inclusion into a rhel release, especially one that is branched from 2.6.18.

Please test again against rhel5.4 and describe the testing that was done to validate the attachments in 4, and set 5,6, and 8.

Thanks, Rob

Comment 14 Babu Moger 2009-09-25 22:59:14 UTC
Rob,
 I regenerated all the patches on top of 2.6.18-164 and tested it. Patches work fine. Here are details. 

Configuration :  LSI rdac storage with 2 luns with 2 paths to each lun(1
active and 1 passive).  

Verified lun discovery. Ran IO with failover/failback tests.  Tests ran fine.  Enabled/disabled logging using module parameter rdac_logging. Noticed failover/failback messages in /var/log/messages file. 

Without these patches, we will not see rdac specific messages during the failures and becomes very difficult to debug.  Tests are still running. Will report back if I see any issues. 
-Thanks, Babu

Comment 15 Babu Moger 2009-09-25 23:20:35 UTC
Created attachment 362724 [details]
Add support for Sun StorageTek ST2500, ST2510 and ST2530

Comment 16 Babu Moger 2009-09-25 23:24:13 UTC
Created attachment 362725 [details]
Add support for two more SUN devices

Comment 17 Babu Moger 2009-09-25 23:25:02 UTC
Created attachment 362726 [details]
Add support for next generation of Dell PowerVault storage array

Comment 18 Babu Moger 2009-09-25 23:26:26 UTC
Created attachment 362727 [details]
Fix for returning correct mode select cmd return info

Comment 19 Babu Moger 2009-09-25 23:27:41 UTC
Created attachment 362728 [details]
[PATCH 1/3][RESUBMIT] scsi_dh_rdac: move the init code from rdac_activate to rdac_attach

Comment 20 Babu Moger 2009-09-25 23:30:01 UTC
Created attachment 362729 [details]
[PATCH 2/3][RESUBMIT] scsi_dh_rdac: changes to collect the rdac debug information during the initialization

Comment 21 Babu Moger 2009-09-25 23:32:00 UTC
Created attachment 362730 [details]
[PATCH 3/3][RESUBMIT] scsi_dh_rdac: changes for rdac debug logging

Comment 22 Rob Evers 2009-09-28 19:05:24 UTC
Thanks Babu,

This patchset applied cleanly to the current rhel5.5 tree and built without issue.

Rob

Comment 24 Babu Moger 2009-09-29 23:23:29 UTC
Rob,
Thanks for the confirmation.
-Babu

Comment 25 Rob Evers 2009-10-01 15:35:13 UTC
*** Bug 526241 has been marked as a duplicate of this bug. ***

Comment 28 Don Zickus 2009-10-13 16:09:35 UTC
in kernel-2.6.18-169.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5

Please do NOT transition this bugzilla state to VERIFIED until our QE team
has sent specific instructions indicating when to do so.  However feel free
to provide a comment indicating that this fix has been verified.

Comment 30 Babu Moger 2009-10-13 23:25:45 UTC
I have verified the patches and also tested the kernel 2.6.18-169.el5. 

Everything is working as expected. 

Configuration:
  LSI storage with scsi rdac handler(with 2 luns with 2 paths(one active and one passive)
  Kernel version 2.6.18-169.el5.
  Tested - failover/failback successfully.
  Also verified logs to see the messages are logged as expected.

-thanks, Babu

Comment 32 Rob Evers 2010-02-09 16:32:33 UTC
Technical note added. If any revisions are required, please edit the "Technical Notes" field
accordingly. All revisions will be proofread by the Engineering Content Services team.

New Contents:
Added rdac support for the following devices:

Sun StorageTek ST2500
Sun StorageTek ST2510
Sun StorageTek ST2530
Sun CSM100_R_FC
Dell PowerVault MD32xx
Dell PowerVault MD32xxi

A bug was fixed where incorrect sense data needed to be flagged as present to upper layers when not handled by the rdac device handler.

Comment 34 errata-xmlrpc 2010-03-30 07:24:48 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0178.html


Note You need to log in before you can comment on or make changes to this bug.